#include <direct.h>
#include <stdio.h>

#include "w_osi.h"
#include "w_io.h"
#include "keyboard.h"
#include "fileio.h"
#include "resource.h"
#include "disk_io.h"
#include "6850.h"
#include <io.h>


//FILE *in, *out;

FILE *infile = NULL;

char sztFileName[_MAX_PATH];
char sztFilePath[_MAX_PATH];
char sztFileHome[_MAX_PATH];
char sztFileExt[5];         
char sztFileSpec[_MAX_PATH];

BYTE KernalRom[2048];

unsigned int ch_in, dr_in;

//*******************************************************************
// File Menu function.
// Open File Input
//*******************************************************************

void FileMenue(void)
{

	if (g_SerialPort.IsFileOpen(TRUE))
		g_SerialPort.CloseFile(TRUE);	
	else
		g_SerialPort.SetFile(TRUE);
	

}

//*******************************************************************
// File SaveMenu function.
// Open File Output
//*******************************************************************

void FileSaveMenue(void)
{
	if (g_SerialPort.IsFileOpen(FALSE))
		g_SerialPort.CloseFile(FALSE);
	else
		g_SerialPort.SetFile(FALSE);
}

////////////////////////////////////////////////////////////////////////////

void LoadROM(void)
{
	unsigned int index,zw;

	// Load BASIC
	if((infile=fopen(BAS,"rb"))==NULL) 
		lstrcpy(ERRORTEXT,"Error opening BASIC ROM in BASIC=");
	else
	{
		for(index=0;index < 8192;index++) 
			RAMptr[index+BASICadr]= (char) fgetc(infile);
		fclose(infile);
		infile = NULL;
	}

	// Load Kernal 
	if((infile=fopen(MON,"rb"))==NULL) 
		lstrcpy(ERRORTEXT,"Error opening MONITOR ROM in KERNAL=");
	else
	{
		
		fread(KernalRom, 1, 2048, infile);
		fclose(infile);
		infile = NULL;
	}

	// Load Rom Extension 1
	if( *ROMEX1file && (infile=fopen(ROMEX1file,"rb"))!=NULL)
	{
		zw=(WORD)filelength(fileno(infile));
		if ((zw>0x00)&(zw<=0x2000)&(ROMEX1<=(0xFFFF-zw+1)))
		{
			 ROMEX1size=zw;
			 for(index=0;index<zw;index++) 
				RAMptr[index+ROMEX1]=(char)fgetc(infile);
		}
		else 
		{
			lstrcpy(ERRORTEXT,"Error opening File at location in ROMEXT1=");
		}
	 
		fclose(infile);
		infile = NULL;

	 }
	

	// Load Rom Extension 2
	if( *ROMEX2file && (infile=fopen(ROMEX2file,"rb"))!=NULL)
	{
		zw=(WORD)filelength(fileno(infile));
		if ((zw>0x00)&(zw<=0x2000)&(ROMEX2<=(0xFFFF-zw+1)))
		{
			ROMEX2size=zw;
			for(index=0;index<zw;index++) 
				RAMptr[index+ROMEX2]=(char)fgetc(infile);
		}
		else lstrcpy(ERRORTEXT,"Error opening File at location in ROMEXT2=");

		fclose(infile);
		infile = NULL;

	}

	// Load Rom Extension 3
	if(*ROMEX3file && (infile=fopen(ROMEX3file,"rb"))!=NULL)
	{
		zw=(WORD)filelength(fileno(infile));
		if ((zw>0x00)&(zw<=0x2000)&(ROMEX3<=(0xFFFF-zw+1)))
		{
			ROMEX3size=zw;
			for(index=0;index<zw;index++) 
				RAMptr[index+ROMEX3]=(char)fgetc(infile);
		}
		else
		{
			lstrcpy(ERRORTEXT,"Error opening File at location in ROMEXT3=");
		}

		fclose(infile);
		infile = NULL;

	 }


	// Load Keybord layout
	LoadKeyTable( KEYTABLE, ERRORTEXT);


}

/***************************************************************************
 Read the specified file into memory at the specified address for the 
 specified length

 Returns 0 on success
		 -1 if parameter failure
		 -2 file failure (use GetLastError() )

***************************************************************************/
int load_rom(LPSTR name, WORD address, DWORD length)
{
	HANDLE hFile = INVALID_HANDLE_VALUE;
	DWORD dwRead;
	BOOL bOK = FALSE;

	if (!name || !*name || length + address > 0xFFFF)
		return -1;
	
	hFile = CreateFile(name, GENERIC_READ, FILE_SHARE_READ,
			NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, 
			NULL );
	
	if (hFile != INVALID_HANDLE_VALUE)
	{
		if (ReadFile(hFile, &RAMptr[address], length, &dwRead, NULL) && dwRead == length)
		{
			bOK = TRUE;	
		}
	
		CloseHandle(hFile);
		hFile = INVALID_HANDLE_VALUE;
	}


	return bOK ? 0 : -2;
}

//*******************************************************************
// ROM File Initialisation.
// Loads system files
//*******************************************************************

void OSIini()
{

	LoadROM();  // Load Osi ROM into memory

	init_cpu();
	Init_Hardware();
	
	CheckMenuItem( GetMenu(ghWnd_Main), IDM_GRAPHIC, MF_UNCHECKED);

	Reset();

}


//*******************************************************************
// Disk Select function.
// Perform File Window. LS=Open/Write
//*******************************************************************


BOOL DiskSelect (TCHAR directory[],int LS)
{
	BOOL bReturn = FALSE;
	
	TCHAR filename[MAX_PATH]  = TEXT("");

	OPENFILENAME ofn;
	ZeroMemory(&ofn,sizeof(OPENFILENAME));
	ofn.lStructSize     = sizeof(OPENFILENAME);
	ofn.hwndOwner       = ghWnd_Main;
	ofn.hInstance       = ghInstance;
	ofn.lpstrFilter     = TEXT("All Programs (*.bas;*.hex;*.txt)\0*.bas;*.hex;*.txt\0")
								TEXT("Disk Images (*.img,*.bin,*.dat)\0*.img,*.bin,*.dat\0")
								TEXT("All Files\0*.*\0");
	ofn.lpstrFile       = filename;
	ofn.nMaxFile        = MAX_PATH;
	ofn.lpstrInitialDir = directory;
	ofn.Flags           = OFN_CREATEPROMPT | OFN_HIDEREADONLY;
	ofn.lpTemplateName  = TEXT("INSERT_DIALOG");

	if (LS==0) // 0=Write, 1=Open
	{
		bReturn = GetSaveFileName(&ofn);
		if (bReturn)
		{
			  if ((!ofn.nFileExtension) || !filename[ofn.nFileExtension])
			  {
				lstrcat(filename,sztFileSpec);  // Create New Filename
			  }
		}
	}
	else
	{
		bReturn = GetOpenFileName(&ofn);
		if (bReturn)
		{
			if ((!ofn.nFileExtension) || !filename[ofn.nFileExtension])
			{
				lstrcat(filename,sztFileSpec);  // Create New Filename
			}
		}
	}
	lstrcpy(sztFileName, filename);

	return bReturn;
}

void Load_ini_file(LPCSTR lpCmdLine)
{
	char temp[_MAX_PATH];
	unsigned int zw;
	char *endptr;

	lstrcpy(sztFileExt, ".*");
	lstrcpy(sztFileSpec, ".BAS");
	lstrcpy(sztFileName, "");
	
	lstrcpy(BAS,sztFileHome);
	lstrcat(BAS,"Basde.rom");
	lstrcpy(MON,sztFileHome);
	lstrcat(MON,"Monde.rom");
	lstrcpy(INIFILE,sztFileHome);
	
	if (lpCmdLine)
		lstrcat(INIFILE, lpCmdLine);
	
	if (!lpCmdLine || lstrlen( lpCmdLine )==0) 
		lstrcat(INIFILE,"OSI.INI"); // default

	lstrcpy(KEYTABLE,sztFileHome);
	lstrcat(KEYTABLE,"KEYTABLE.DAT");
	*ERRORTEXT = '\0';


	if (GetPrivateProfileString("ROM","BASIC","",temp,79,INIFILE))
	{
		lstrcpy(BAS,sztFileHome);
		lstrcat(BAS,temp);
	}

	if (GetPrivateProfileString("ROM","KERNEL","",temp,79,INIFILE))
	{
		lstrcpy(MON,sztFileHome);
		lstrcat(MON,temp);
	}
	
	//Get kernel rom type (OSI or CEGMON)
	gKernelType = GetPrivateProfileInt("ROM", "KERNELTYPE", 0, INIFILE);
	if (gKernelType < 0 || gKernelType > 1) gKernelType = 1;

	if (GetPrivateProfileString("ROM", "CHARGEN","",temp,79, INIFILE))
	{
		lstrcpy(CHARGEN, sztFileHome);
		lstrcat(CHARGEN, temp);
	}



	gCharSet = GetPrivateProfileInt("ROM","CHARSET",0,INIFILE);
	if ( gCharSet < 0 || gCharSet > 2) gCharSet = 0;

	gRevFont = GetPrivateProfileInt("ROM","FONTREV",1,INIFILE);
	if (gRevFont < 0 || gRevFont > 1) gRevFont = 1;

	gBasicEnable = GetPrivateProfileInt("ROM","BASICENABLE",1,INIFILE);
	if (gBasicEnable < 0 || gBasicEnable > 1) gBasicEnable = 1;

	gMachineType = GetPrivateProfileInt("MACHINE","TYPE",3,INIFILE);
	if (gMachineType < 0 || gMachineType > 6) gMachineType = 3;

	gDiskEnable = GetPrivateProfileInt(_T("DISK"),_T("ENABLE"),1,INIFILE);
	if (gDiskEnable < 0 || gDiskEnable > 1) gDiskEnable = 1;

	gDriveType = GetPrivateProfileInt(_T("DISK"),_T("DRIVETYPE"),0,INIFILE);
	if (gDriveType < 0 || gDriveType > 1) gDriveType = 0;

	gDriveNum = GetPrivateProfileInt(_T("DISK"),_T("NUMDRIVES"),2,INIFILE);
	if (gDriveNum < 0 || gDriveNum > 4) gDriveNum = 2;

	if (GetPrivateProfileString("EXTENSIONS","RAMEXT1","",temp,79,INIFILE))
	{
		RAMEX1=(WORD)strtol(temp,&endptr,0);
		RAMEX1size=(WORD)strtol(endptr+1,NULL,0);
	}

	if (GetPrivateProfileString("EXTENSIONS","RAMEXT2","",temp,79,INIFILE))
	{
		RAMEX2=(WORD)strtol(temp,&endptr,0);
		RAMEX2size=(WORD)strtol(endptr+1,NULL,0);
	}

	if (GetPrivateProfileString("EXTENSIONS","ROMEXT1","",temp,79,INIFILE))
	{
		ROMEX1=(WORD)strtol(temp,&endptr,0);
		lstrcpy(ROMEX1file,sztFileHome);
		lstrcat(ROMEX1file,endptr+1);
	}

	if (GetPrivateProfileString("EXTENSIONS","ROMEXT2","",temp,79,INIFILE))
	{
		ROMEX2=(WORD)strtol(temp,&endptr,0);
		lstrcpy(ROMEX2file,sztFileHome);
		lstrcat(ROMEX2file,endptr+1);
	}

	if (GetPrivateProfileString("EXTENSIONS","ROMEXT3","",temp,79,INIFILE))
	{
		ROMEX3=(WORD)strtol(temp,&endptr,0);
		lstrcpy(ROMEX3file,sztFileHome);
		lstrcat(ROMEX3file,endptr+1);
	}

	if (GetPrivateProfileString("Keyboard","KEYFILE","",temp,79,INIFILE))
	{	
		lstrcpy(KEYTABLE,sztFileHome);
		lstrcat(KEYTABLE,temp);
	}

	zw = GetPrivateProfileInt("Screen","Screen64x16",1,INIFILE);
	if (zw < 0 || zw > 2) zw = 1;
	if (zw)
		g64x16Mode = 1 ;
	else
		g64x16Mode = 0;


	zw = GetPrivateProfileInt("Screen","Char_size",1,INIFILE);
	if (zw < 0 || zw > 2) zw = 1;
	
	gScreenMode &= ~SCREENSIZE_MASK;
	gScreenMode |= zw;

	zw = GetPrivateProfileInt("Screen", "FixedWidth",1,INIFILE);
	gScreenMode &= ~RESIZE_MASK;
	if (zw)
		gScreenMode |= RESIZE_MASK;

	//load color mode
	gColorMode = GetPrivateProfileInt("Screen","ColorPref", 1,INIFILE);
	if (gColorMode < 0 || gColorMode > 2)
		gColorMode = 1; 


	IRQ_Interrupt = GetPrivateProfileInt("IRQ_NMI","IRQ_Interrupt",0,INIFILE);

	NMI_Interrupt = GetPrivateProfileInt("IRQ_NMI","NMI_Interrupt",0,INIFILE);

	if (GetPrivateProfileString("RAM","RAMTOP","",temp,79,INIFILE))
	{
		RAMTOP=(WORD)strtol(temp,NULL,0);
		if (RAMTOP<0x03FF)
			RAMTOP=0x03FF;
		
		if (gBasicEnable)
		{
			if (RAMTOP > 0x7FFF)
				RAMTOP=0x7FFF;
		}
		else
		{
			if (RAMTOP > 0xBFFF)
				RAMTOP = 0xBFFF;
		}
	}

	RAMGDC = GetPrivateProfileInt("RAM","RAMGDC",0,INIFILE);
	if (RAMGDC < 0 || RAMGDC > 1) RAMGDC = 1;


	if (GetPrivateProfileString("Debug","BPaddress","",temp,79,INIFILE))
	{
		stop_loc=(WORD)strtol(temp,NULL,0);
		if (stop_loc>0xFFFF)
			stop_loc=0xFFFF;
	}
}
