/// hWndMonitor feature Calls

////////////////////////////////////////////////////////////////////////////
#include "w_osi.h"
#include "resource.h"
#include "Monitor.h"
#include "keyboard.h"
#include "fileio.h"
#include "6502.h"
#include "w_io.h"
#include <windowsx.h>
#include <process.h>	//spawnlp

//global flag to indicate memory write
BOOL	PokeFlag=FALSE;					// Set if Memory Write

BOOL	MSEnable=TRUE;                  // Enables Memory/Stack display
BOOL	DEnable	=FALSE;					// Enables Debug Display
BOOL	DebugRDY=TRUE;					// Debug Status Flag
BOOL	SEnable	=TRUE;					// Enables Debug Step
BOOL	SMode	=FALSE;					// Defines present Mode (FALSE=Step Mode)

int		nHexRows;
int		nListRows;

HWND	hWndMonitor = NULL;				// Handle of Debug dialog
char	string[256];					// short string buffer
unsigned int memd=0;
BOOL	CodeERR	=FALSE;					// Enables Error Code handling

	


void Close_Monitor()
{
	if (hWndMonitor && IsWindow(hWndMonitor))
	{
		PostMessage(hWndMonitor, WM_CLOSE, 0, 0L);
	}
}

void Open_Monitor(HWND hwnd, char *)
{
	if(!IsWindow(hWndMonitor))
	{
		// Create modeless dialog only if it's not here already
		CheckMenuItem(GetMenu(ghWnd_Main),IDM_MONITOR,MF_BYCOMMAND|MF_CHECKED);
		
		hWndMonitor = CreateDialog(ghInstance,MAKEINTRESOURCE(IDD_DEBUG),hwnd,(DLGPROC) Monitor);
		
		wsprintf(string,"%04X",memd);
		SetDlgItemText(hWndMonitor,IDC_ADRESSE, string);

		ShowWindow(hWndMonitor, SW_SHOW);
		
		if(IsWindow(h_speed))
			PostMessage(h_speed, WM_CLOSE, 0, 0L);   // Removes Speed disp if present
	}
	else
	{
		SetFocus(hWndMonitor);
	}
}

// Subclass edit control
BOOL CALLBACK EditIntercept(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	//WORK in progress
	//HWND hParentWnd = GetParent (hWnd);

	switch (msg) 
	{
		case WM_ERASEBKGND:
			return TRUE;
	}               
	/* and always let the edit control do its thing  */
	return (BOOL)CallWindowProc((WNDPROC) GetClassLong(hWnd, GCL_WNDPROC), hWnd, msg, wParam , lParam);
}

void ReCalcSizes()
{
	HWND hWnd;
	HDC hDC;
	TEXTMETRIC tm;
	HFONT hFont, hOldFont = NULL;
	RECT rect;

	nHexRows=8;
	hWnd = GetDlgItem( hWndMonitor, IDC_LIST_HEX);
	
	if (hWnd)
	{
		int nVertOffset = 0;
		hDC = GetDC(hWnd);

		GetClientRect(hWnd, &rect);

		if (hDC)
		{
			
			hOldFont = NULL;

			// Send the WM_GETFONT message to the edit control. The return
			// value is a handle to the font currently used by the edit
			// control.
			hFont= (HFONT) SendMessage(hWnd, WM_GETFONT, 0, 0L);

			// If the font used is not the system font, select it.
			if (hFont != NULL)
			   hOldFont = (HFONT) SelectObject(hDC, hFont);

			// Call GetTextMetrics using hDC to fill a TEXTMETRIC structure
			// with information about the font used by the edit control,
			// which is selected into hDC. The field of interest is
			// tmHeight.
		
			
			GetTextMetrics(hDC, &tm);
			
			if (hOldFont)
				SelectObject(hDC, hOldFont);

			ReleaseDC(hWnd, hDC);


			nVertOffset = tm.tmHeight + tm.tmExternalLeading;
		
			nHexRows = (rect.bottom-rect.top )/nVertOffset;				
		}


	}

	nListRows = 7;
	hWnd = GetDlgItem( hWndMonitor, IDC_LIST_CODE);
	if (hWnd)
	{
		int nVertOffset = 0;
		HDC hDC = GetDC(hWnd);


		if (hDC)
		{
			TEXTMETRIC tm;
			HFONT hOldFont = NULL;

			// Send the WM_GETFONT message to the edit control. The return
			// value is a handle to the font currently used by the edit
			// control.
			hFont= (HFONT) SendMessage(hWnd, WM_GETFONT, 0, 0L);

			// If the font used is not the system font, select it.
			if (hFont != NULL)
			   hOldFont = (HFONT) SelectObject(hDC, hFont);

			// Call GetTextMetrics using hDC to fill a TEXTMETRIC structure
			// with information about the font used by the edit control,
			// which is selected into hDC. The field of interest is
			// tmHeight.
		
			
			GetTextMetrics(hDC, &tm);
			
			if (hOldFont)
				SelectObject(hDC, hOldFont);

			ReleaseDC(hWnd, hDC);

			nVertOffset = tm.tmHeight + tm.tmExternalLeading;
			GetClientRect(hWnd, &rect);
		
			nListRows = (rect.bottom-rect.top)/nVertOffset;
				
		}


	}




}

//*******************************************************************
// Monitor - handle Dialog messages
//
// paramaters:
//             hdlg          - The window handle for this message
//             msg	        - The message number
//             wparam        - The WPARAM parameter for this message
//             lparam        - The LPARAM parameter for this message
//
//*******************************************************************

BOOL CALLBACK  Monitor(HWND hdlg, UINT msg, WPARAM wparam, LPARAM lparam)
{
	PAINTSTRUCT	ps;	   				// used in WM_PAINT
	char adr[5];
	int zw;
	static RECT rSize, rDasm;
	static POINT ptMin = {0,0};
	static POINT ptLast= {0,0};

	switch(msg)
	{
		case WM_INITDIALOG:
			{
				
				GetWindowRect(hdlg, &rSize);
				ptMin.x = abs(rSize.right-rSize.left);
				ptMin.y = abs(rSize.bottom-rSize.top);
				ptLast = ptMin;

				HWND hEdit = GetDlgItem (hdlg, IDC_LIST_HEX);
				if (hEdit)
				{
					//GetWindowRect(hEdit, rDump);
					SetWindowLong(hEdit, GWL_WNDPROC, (DWORD) EditIntercept);
					SendMessage(hEdit, WM_SETFONT,(WPARAM) debugfont, 0);

				}
					hEdit = GetDlgItem (hdlg, IDC_LIST_CODE);
				if (hEdit)
				{
					//GetWindowRect( hEdit, rDump );
					SetWindowLong(hEdit, GWL_WNDPROC, (DWORD) EditIntercept);
					//SendMessage(hEdit, WM_SETFONT,(WPARAM) debugfont, 0);
				}

				ReCalcSizes();
				display_registers();
				DEnable=TRUE;

			}

			break;

		case WM_CLOSE:
			//DeleteObject(hfontDlg);
			DestroyWindow(hWndMonitor);
			CheckMenuItem(GetMenu(ghWnd_Main),IDM_MONITOR,MF_BYCOMMAND|MF_UNCHECKED);
			hWndMonitor=NULL;
			DEnable=FALSE;
			SEnable=TRUE;
			Clear_KeyState();
			break;

		case WM_PAINT:
			BeginPaint(hdlg,&ps);
			EndPaint(hdlg,&ps);
			return(TRUE);
		
		case WM_SIZE:
			{
				RECT rect;
				POINT ptCur;
				int  cx,cy;

				if ( wparam != (WPARAM) SIZE_RESTORED)
					return TRUE;

				

				if ( ptMin.x == 0 && ptMin.y == 0) 
					return TRUE;
				
				cx = LOWORD(lparam); 
				cy = HIWORD(lparam);

				if (cx <= 0 || cy <= 0)
					return TRUE;

				GetWindowRect(hdlg, &rect);

				ptCur.x = rect.right-rect.left;
				ptCur.y = rect.bottom-rect.top;
				
				cx = ptCur.x - ptLast.x;
				cy = ptCur.y - ptLast.y;
    
				ptLast.x += (cy/2)*2;  //prevent accumulation of roundoff errors
				ptLast.y += cy;


				//MoveControl(hdlg, IDOK, xDiff/2, yDiff);
    
				//GrowWindow(hdlg, IDC_LIST_HEX, (cx/2)*2, yDiff);

				GrowWindow(hdlg, IDC_LIST_HEX, 0, cy);
				GrowWindow(hdlg, IDC_LIST_CODE,0, cy);
				ReCalcSizes();
				  
				InvalidateRect(hdlg, NULL,TRUE); //erase resize ctrl
				return 0;
			}
			break;

		case WM_GETMINMAXINFO:
			{
				LPMINMAXINFO lpmmi = (LPMINMAXINFO) lparam;
				lpmmi->ptMinTrackSize = ptMin;
				lpmmi->ptMaxSize.x = ptMin.x;
				lpmmi->ptMaxTrackSize.x = ptMin.x;
				
				return 0;
			}
			break;

		case WM_COMMAND:
			switch (GET_WM_COMMAND_ID(wparam, lparam))
			{
				case IDCANCEL:
					PostMessage(hWndMonitor, WM_CLOSE, 0, 0L);
					break;

				case IDSTEP:
					SEnable=TRUE;
					SMode=FALSE;
					break;

				case IDRUN:
					SEnable=TRUE;
					SMode=TRUE;
					break;

				case IDGO:
					// Get current PCGO text field
					if (GetDlgItemText(hWndMonitor, IDC_PCGO, adr, 5)==0) 
						lstrcpy(adr,"0000");
					sscanf(adr,"%04X", &zw);
					wsprintf(adr,"%04X", zw);
					SetDlgItemText(hWndMonitor, IDC_PCGO, adr);
					R.PC.W=zw;
					SEnable=TRUE;
					SMode=FALSE;		// Enable Step Mode
					PokeFlag=TRUE;
					SEnable=TRUE;
					display_registers();
					SEnable=FALSE;
					break;

				case IDBP:
					// Get current PCBP text field
					if (GetDlgItemText(hWndMonitor, IDC_PCBP, adr, 5)==0) 
						lstrcpy(adr,"0000");
					sscanf(adr,"%04X", &zw);
					wsprintf(adr,"%04X", zw);
					SetDlgItemText(hWndMonitor, IDC_PCBP, adr);
					stop_loc=zw;
					break;

				case IDBPC:
					// Set current PCBP text field to FFFF
					if (GetDlgItemText(hWndMonitor, IDC_PCBP, adr, 5)==0) 
						lstrcpy(adr,"0000");
					zw=0xFFFF;
					wsprintf(adr,"%04X", zw);
					SetDlgItemText(hWndMonitor, IDC_PCBP, adr);
					stop_loc=zw;
					break;

				case IDC_SOFTRESET:     			 // Soft Reset CPU
					Reset();
					SEnable=TRUE;
					SMode=FALSE;						// Enable Step Mode
					PokeFlag=TRUE;
					SEnable=TRUE;
					display_registers();
					SEnable=FALSE;
					break;

				case IDC_HARDRESET:     			 // Hard Reset CPU
					OSIini();
					SetScreenCheck(gScreenMode);
					PostMessage(hWndMonitor, WM_CLOSE, 0, 0L);   // Close debugger window
					break;

				case IDC_EDITSETUP:     			 // Start Text Editor to edit parameters
					// Display Help file with Notepad Editor.
					spawnlp(P_NOWAIT,"Notepad.exe","Notepad.exe",INIFILE , NULL);
					break;

				case IDC_SHOWMEM:
					MSEnable=TRUE;
					PokeFlag=TRUE;
					SEnable=TRUE;
					display_registers();
					SEnable=FALSE;
					break;

				case IDC_CODEERR:
					CodeERR=!CodeERR;               // Toggle Error handling flag
					display_registers();
					break;

				case IDC_SHOWSTACK:
					MSEnable=FALSE;
					PokeFlag=TRUE;
					SEnable=TRUE;
					InvalidateRect(hdlg,NULL,TRUE);
					display_registers();
					SEnable=FALSE;
					break;


				default:
					return(TRUE);
			}
			default:
			return(FALSE);
		}
	return(FALSE);
}


void display_registers()
{
	char adr[5];

	unsigned int index;
	int index1;
	int index2;
	unsigned int zw;

	int nRows;

	BYTE P;

	if(!IsWindow(hWndMonitor))
		return;

	CheckDlgButton(hWndMonitor, IDC_CODEERR, CodeERR);
	if (SEnable)
	{
		// Show IRQ/NMI Mem/Stack,...Status in checkbox
		CheckDlgButton(hWndMonitor, IDC_SHOWMEM, MSEnable);
		CheckDlgButton(hWndMonitor, IDC_SHOWSTACK, !MSEnable);

		if (IEnable) 
			index=1;
		else 
			index=2;
		if (IRQ_Interrupt>0) 
			CheckDlgButton(hWndMonitor, IDC_IRQ, index);
		else 
			CheckDlgButton(hWndMonitor, IDC_IRQ, 0);
		
		if (NMI_Interrupt>0) 
			CheckDlgButton(hWndMonitor, IDC_NMI, index);
		else 
			CheckDlgButton(hWndMonitor, IDC_NMI, 0);

		wsprintf(string,"0x%02X",R.A);
		SetDlgItemText(hWndMonitor,IDC_P_A,string);
		SetDlgItemText(hWndMonitor,IDC_P_A_BIN,binary(R.A));

		wsprintf(string,"0x%02X",R.X);
		SetDlgItemText(hWndMonitor,IDC_P_X,string);
		SetDlgItemText(hWndMonitor,IDC_P_X_BIN,binary(R.X));

		wsprintf(string,"0x%02X",R.Y);
		SetDlgItemText(hWndMonitor,IDC_P_Y,string);
		SetDlgItemText(hWndMonitor,IDC_P_Y_BIN,binary(R.Y));

		wsprintf(string,"0x%02X",R.S);
		SetDlgItemText(hWndMonitor,IDC_P_S,string);
		SetDlgItemText(hWndMonitor,IDC_P_S_BIN,binary(R.S));

		wsprintf(string,"0x%04X",eff_adr);
		SetDlgItemText(hWndMonitor,IDC_R_PC,string);

		wsprintf(string,"0x%04X",R.PC.W);
		SetDlgItemText(hWndMonitor,IDC_P_PC,string);

		binary(R.PC.B.h);
		lstrcpy(tmp,string);
		binary(R.PC.B.l);
		lstrcat(tmp," ");
		lstrcat(tmp,string);
		SetDlgItemText(hWndMonitor,IDC_P_PC_BIN,tmp);

		P=(BYTE)(R.P.C
		+ (((BYTE)R.P.Z)<<1)
		+ (((BYTE)R.P.I)<<2)
		+ (((BYTE)R.P.D)<<3)
		+ (((BYTE)R.P.B)<<4)
		+ 0X20
		+ (((BYTE)R.P.V)<<6)
		+ (((BYTE)R.P.N)<<7));
		wsprintf(string,"0x%02X",P);
		SetDlgItemText(hWndMonitor,IDC_P_P,string);
		SetDlgItemText(hWndMonitor,IDC_P_P_BIN,binary(P));



		// Get current adress text field
		if (GetDlgItemText(hWndMonitor, IDC_ADRESSE, adr, 5)==0) 
			lstrcpy(adr,"0000");
		sscanf(adr,"%04X", &zw);
		wsprintf(adr,"%04X", zw);
		SetDlgItemText(hWndMonitor, IDC_ADRESSE, adr);

		if (zw!=memd)
		{
			PokeFlag=TRUE;
			memd=zw;
		}

		// Set current PCGO text field
		wsprintf(adr,"%04X", R.PC.W);
		SetDlgItemText(hWndMonitor, IDC_PCGO, adr);

		// Set current PCBP text field
		wsprintf(adr,"%04X", stop_loc);
		SetDlgItemText(hWndMonitor, IDC_PCBP, adr);

		index=0;
		*buffer = 0;
		*tmp = 0;

		if (PokeFlag)
		{
			PokeFlag=FALSE;
			zw=memd;

			nRows = nHexRows;
			

			if (!MSEnable)
			{ 
				if (nRows >15)
					zw = 0x100;
				else 
					zw = 0x100+ ( min ((R.S & 0xF0), 0x100-(nRows<<4)));

				
			}


			for(index1=0;index1 < nRows;index1++)
			{
				wsprintf(buffer,"$%04X ",(zw+index1*16)&0xFFFF);
				lstrcat(tmp,buffer);
				for(index2=0;index2<16;index2++)
				{
					if ( ( (zw+index) < (R.S+ (unsigned int) 0x100) ) && (!MSEnable))
						wsprintf(buffer,"-%02X",Peek(zw+index++));
					else
						wsprintf(buffer," %02X",Peek(zw+index++));
					lstrcat(tmp,buffer);
				}
				lstrcat(tmp,"\r\n");

				if (!MSEnable && (zw+index > 0x01FF) )
					break;
			}
			SetDlgItemText(hWndMonitor, IDC_LIST_HEX, tmp);
		}
		
		index=0;
		lstrcpy(tmp,"Address  Code\r\n");
		
		nRows = nListRows;

		nRows--;				
		
		for( index1=0; index1<nRows; index1++)
		{
			wsprintf(buffer,"$%04X    ",(R.PC.W+index)&0xFFFF);
			lstrcat(tmp,buffer);
			lstrcpy(buffer,"");
			index+=Disassemble(buffer, (R.PC.W+index)&0xFFFF);
			lstrcat(tmp,buffer);
			lstrcat(tmp,"\r\n");
			if (index > 0xFFFF)
				break;
		}
		SetDlgItemText(hWndMonitor, IDC_LIST_CODE, tmp);
		UpdateWindow(GetDlgItem(hWndMonitor, IDC_LIST_CODE)); 
	}
	SEnable=SMode;
	DebugRDY=TRUE;
}


char *binary(BYTE byte)
{
  int z;

  lstrcpy(string,"00000000");
  for(z=0;z<8;z++)
  {
	 if (byte & (0x01<<z)) 
		string[7-z]='1';
  }
  return(string);
}


