#ifndef _W_IO_H
#define _W_IO_H

#include <windows.h>
/// IO feature Calls

void OSI_VIDC(unsigned int VIDA);            /// Screen Char Output  8x8-12x12-16x16
void OSI_GDC(unsigned int VIDA);            /// Screen Pixel Output
void restvid(void);           			/// Restore Video
void restgdc(void);           			/// Restore Hires Video
void clrvid(void);           			/// CLR Video
void ToggleGraphik(void);           			/// Set Graphic Mode
void Terminate(void);
void Quit(char message[]);
void InitVideo();

BOOL CALLBACK  VideoDlg(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
								  // PROTOTYPES //

extern unsigned int VIDCadr;		// default D000 VIDC Startadress l=0800
extern unsigned int GDCadr;			// default 8000 GDC Startadress  l=2000
extern unsigned int RAMGDC;			// Hires memory for GDC
extern BOOL GEnable;                // Enables 8000 Graphics display
extern int gSoundCtrl;				// Sound Control


// Screen settings
// Bits 1 & 0 control target size, 00=256x256,01=512x512, 10=768x768, 11=??
// Bit  3 & 2 control 32/64 rowlen.  00=32 rowlen,  01=64 rowlen,   10=64x16,   11=??
// Bit  4 = 64/32 mode for 540 (1=32)
// Bit  5 =	color enable
// Bit  6 = dont maintain window width (64 col mode = 2x width)

#define MODE64X16  0x08
#define OSI540     0x04
#define SCREENSIZE_MASK 0x03
#define WIDTH_MASK 0x10
#define COLOR_MASK 0x20
#define RESIZE_MASK 0x40

#define HBORDER (0x0C)
#define VBORDER (0x10)

// 0 = 32x32, 256
// 1 = 32x32  512
// 2 = 32x32  768
// 3 = undef  
// 4 = 64x32  256
// 5 = 64x32  512
// 6 = 64x32  768
// 7 = undef
// 8 = 64x16  256x256 Each char 4x16
// 9 = 64x16  512
// A = 64x16  768
// B = undef
// C = undef
// D = undef
// F = undef
extern int gScreenMode;
extern int g64x16Mode;
extern int gColorMode;


#endif _W_IO_H
