
								 // DEFINES //


#define WIN32_LEAN_AND_MEAN
#ifndef _WIN32
	#define _WIN32
#endif
#define OEMRESOURCE
#define STRICT
#define _cplusplus
#pragma hdrstop

#include "w_osi.h"
#include "resource.h"
#include "keyboard.h"
#include "disk_io.h"
#include "w_io.h"
#include "6850.h"
#include "Monitor.h"
#include "Fileio.h"
#include <windowsx.h>
#include <process.h>
#include <COMMCTRL.H>

#ifdef __BORLANDC__ 
	#pragma argsused
#endif


#define IDRESET	0x20
								// GLOBALS //

HWND	ghWnd_Main = NULL; 		// save window handle
HINSTANCE ghInstance = NULL; 	// save instance
HWND	h_speed = NULL;			// Handle of Speed dialog
HACCEL	ghAccel = NULL;

HFONT	debugfont = (HFONT)0;	// Debug Font

RECT	rcWinRect;				// Display rectangle

char buffer[8192];              // used to print text
char tmp[8192];                 // used to store temp data


HDC about_window = NULL;        // About window hdc
HDC main_window = NULL; 		// main window hdc


int tape_1s=0;					// Select indicators

unsigned long int t_speed;
unsigned long int t_time_speed;
unsigned long int timer=0, t_time=0, aw_speed, SpeedPos, Speed;

DWORD gClocks = 0;				//emulated CPU clock count

unsigned long int IRQ_Interrupt;
unsigned long int NMI_Interrupt;

unsigned long int irq_counter;
unsigned long int nmi_counter;
unsigned long int t_check = 0;
unsigned int irqkey=0;				// Current scan code pressed



BOOL IEnable=FALSE;                 // Enables Interrupt function (MMI + IRQ)
BOOL Dis_adr=FALSE;                 // Exist active DIS_ASM range
BOOL VIDCpoke=FALSE;				// Text write Flag for Hires
int S_dis, E_dis;

BOOL Abort=TRUE;					// Program Abort flag
BOOL bIsNT = TRUE;

unsigned char far *RAMptr;          // Universal 64k memory area
unsigned int RAMTOP, stop_loc;

unsigned int RAMTOPadr=0x03FF;		// default 03FF Ramtop 1kb
unsigned int KERNALadr=0xF800;		// default D000 VIDC Startadress l=0800
unsigned int BASICadr=0xA000;		// default A000 BASIC ROM Startadresse l=2000
unsigned int RAMEX1,RAMEX2,ROMEX1,ROMEX2,ROMEX3; // Extension RAM,ROM
unsigned int RAMEX1size,RAMEX2size,ROMEX1size,ROMEX2size,ROMEX3size;


//storage for paths, filenames
char ROMEX1file[_MAX_PATH];			// Extension ROM file names
char ROMEX2file[_MAX_PATH];			// Extension ROM file names
char ROMEX3file[_MAX_PATH];			// Extension ROM file names
char BAS[_MAX_PATH];				// Basic rom     
char MON[_MAX_PATH];     			// Monitor Rom
char CHARGEN[_MAX_PATH];			// Character generator ROM
char KEYTABLE[_MAX_PATH];			// Keyboard mapping
char INIFILE[_MAX_PATH];			// INI file 
char ERRORTEXT[1024];				// Error message buffer    


int gMachineClass = 1;				// C1 type, C2 type 
int gMachineType = 0;				// machine emulation
int gCharSet = 0;					// character generator
int gRevFont = 1;					// reverse font (C2/C4)
int gBasicEnable = 1;				// basic in rom $A000
int gKernelType = 0;				// 0 = SYN600, 1=CEGMON
int gDiskEnable = 1;				// Is disk controller enabled
int gDriveType = 0;					// 0=5.25, 1=8
int gDriveNum = 2;					// 1-4


FILE* disfile = NULL;				// Disassembler File

BOOL IsNT()
{
	return bIsNT;
}

////////////////////////////////////////////////////////////////////////////
void AllocMem(void)
{
	if ( ( RAMptr = (unsigned char *) malloc (0xFFFF +1) ) == NULL ) 
		Quit("Error allocating 64k memory for CPU");
}


void InitGlobals()
{

	disfile = NULL;

	int index;

	for(index=0;index<0xFFFF;index++) 
		RAMptr[index]=0x00;

	IRQ_Interrupt=0;
	NMI_Interrupt=0;
	IRQ=0;
	NMI=0;
	
	RAMEX1size=0;
	RAMEX2size=0;
	ROMEX1size=0;
	ROMEX2size=0;
	ROMEX3size=0;
	*ROMEX1file = '\0';
	*ROMEX2file = '\0';
	*ROMEX2file = '\0';
	
	RAMTOP=RAMTOPadr;
	stop_loc=0xFFFF;
	gScreenMode=3;

	aw_speed=100;
	SpeedPos=100;
	Speed=100;

}



// Set machine emulation mode
// set emulation addresses for hardware
void SetConfiguration(int nMachineType)
{
	if (nMachineType < C1P || nMachineType > CUSTOM)
		return;
	
	gMachineType = nMachineType;

	switch (nMachineType)
	{
		
		case C1P:	//C1P, Supoerboard, OSI charset       		
		case UK101:		//UK101, Supoerboard, UK101 charset   	
		case C1PMF:		//C1P with floppies?
			gMachineClass = C1Machine;
			gScreenMode &= ~(OSI540 | WIDTH_MASK | COLOR_MASK); //32 long row
			if (g64x16Mode)
				gScreenMode |= MODE64X16;	
			break;
			                  	
		case C2P:		//OSI 500 CPU & Basic in ROM PIA $F700         	
		case C4P:		//OSI 502 CPU & Basic in ROM           	
		case C4PMF:		//OSI 505 CPU & dual floppies 48K ram PIA $F700
			gMachineClass = C2Machine;
			gScreenMode &= ~MODE64X16;
			gScreenMode |= ( OSI540 | WIDTH_MASK); //64 long row
			break;
	}

	keyscanptr=RAMptr+0xDF00;
	keyptr=RAMptr+0xDF01;

	*keyptr=0xFF;
	*keyscanptr=0xFF;

	/*	
	if ( gMachineType == C4PMF || gMachineType == C1PMF )
	{

		acia2cptr=RAMptr+0xC010;
		acia2dptr=RAMptr+0xC011;
		portaptr=RAMptr+0xC000;
		portbptr=RAMptr+0xC002;
		
		*acia2cptr=0x0E;
		*acia2dptr=0x00;

		*portaptr=0xEC;
		*portbptr=0xFF;
		
	}
	*/

}

void HReset(LPCSTR szINI)
{

	Load_ini_file(szINI);
		
	SetConfiguration(gMachineType);				// init variables

	g_DiskPort.Reset();
	g_DiskPort.SetINIFile(INIFILE);
	
	if (gDiskEnable)
		g_DiskPort.SetDriveConfig(gDriveType, gDriveNum);

	OSIini(); //load disk files

	SetScreenCheck(gScreenMode);

	g_SerialPort.SetINIFile(INIFILE);
	g_SerialPort.LoadConfig();



}


void Reset(void)           			/// Reset CPU
{
	reset_cpu();
	IEnable = FALSE;
	CheckMenuItem( GetMenu(ghWnd_Main), IDM_INT, MF_UNCHECKED);
	IRQ=0;
	NMI=0;
	GEnable = FALSE;


	//CloseDiskFiles();
	
	if ( gDiskEnable )
	{
		
		int i;
		TCHAR szEntry[10];
		TCHAR szFile[MAX_PATH];
		g_DiskPort.Reset();

		for (i = 0; i < 4; i++)
		{
			_stprintf(szEntry, _T("%s%c"), _T("DRIVE_"), _T('A')+i);
			if (GetPrivateProfileString("DISK",szEntry,"",
						szFile,_MAX_PATH,INIFILE))
			{
				g_DiskPort.OpenFile(i+1, szFile);
			}

		}
		
	}

	restvid();
	Clear_KeyState();
}

//*******************************************************************
// About - handle Dialog messages
//
// paramaters:
//             hdlg          - The window handle for this message
//             msg	        - The message number
//             wparam        - The WPARAM parameter for this message
//             lparam        - The LPARAM parameter for this message
//
//*******************************************************************
BOOL CALLBACK  About(HWND hdlg, UINT msg, WPARAM wparam, LPARAM lparam)
{
	
	PAINTSTRUCT	ps;	   				// used in WM_PAINT
	BITMAP bm;

	HDC cpu_window = NULL; 	   		// CPU window hdc
	HBITMAP cpu_bitmap = NULL;			// CPU bitmap handle

	lparam;

	switch(msg)
	{
		case WM_INITDIALOG:
			about_window = GetDC(hdlg);
			cpu_window = CreateCompatibleDC(main_window);
			cpu_bitmap = LoadBitmap(ghInstance, MAKEINTRESOURCE(IDB_6502));
			break;

		case WM_PAINT:
			BeginPaint(hdlg,&ps);
			EndPaint(hdlg,&ps);
			SelectObject(cpu_window, cpu_bitmap);
			GetObject(cpu_bitmap, sizeof(BITMAP), &bm);
			BitBlt(about_window, 16, 16, bm.bmWidth, bm.bmHeight, cpu_window, 0, 0, SRCCOPY);
			return(TRUE);

		case WM_COMMAND:
			switch (GET_WM_COMMAND_ID(wparam, lparam))
			{
				case IDOK:
					DeleteDC(cpu_window);
					DeleteObject(cpu_bitmap);
					EndDialog(hdlg, TRUE);
					Clear_KeyState();
					break;

				default:
					return(TRUE);
			}
			default:
			return(FALSE);
	}
	return(FALSE);
}

//*******************************************************************
// Speed - handle Dialog messages
//
// paramaters:
//             hdlg          - The window handle for this message
//             msg	        - The message number
//             wparam        - The WPARAM parameter for this message
//             lparam        - The LPARAM parameter for this message
//
//*******************************************************************
BOOL CALLBACK  S_dialog(HWND hdlg, UINT msg, WPARAM wparam, LPARAM lparam)
{
	HWND SpeedBar;
	PAINTSTRUCT	ps;	   				// used in WM_PAINT

	switch(msg)
	{
		case WM_INITDIALOG:
			// Set Speed bar                   IDC_SPEEDSCROLL
			SpeedBar = GetDlgItem(hdlg, IDC_SPEEDSCROLL);
			SetScrollRange(SpeedBar, SB_CTL, 100, 300, FALSE);
			SetScrollPos(SpeedBar, SB_CTL, Speed, TRUE);
		break;

		case WM_CLOSE:
			DestroyWindow(hdlg);
			h_speed=NULL;
			Clear_KeyState();
		break;

		case WM_PAINT:
			BeginPaint(hdlg,&ps);
			EndPaint(hdlg,&ps);
		return(TRUE);

		case WM_HSCROLL:
			// Change Speed scroll bar in 3 Steps
			SpeedBar = (HWND)lparam;
			Speed=GetScrollPos(SpeedBar, SB_CTL);

			if (LOWORD(wparam)==SB_THUMBPOSITION)
			{
				Speed=(short int) HIWORD(wparam)+50;
				Speed=(Speed/100)%5;
				SetScrollPos(SpeedBar, SB_CTL, Speed*=100, TRUE);
			}
			
			if (LOWORD(wparam)==SB_LINELEFT)
			{
				Speed-=100;
				SetScrollPos(SpeedBar, SB_CTL, Speed, TRUE);
			}
			if (LOWORD(wparam)==SB_LINERIGHT)
			{
				Speed+=100;
				SetScrollPos(SpeedBar, SB_CTL, Speed, TRUE);
			}
			switch(Speed/100)
			{
				case 1: 
					SpeedPos=100; 
					break;
				case 2: 
					SpeedPos=200; 
					break;
				case 3: 
					SpeedPos=400; 
					break;
			}
			break;

		case WM_COMMAND:
			switch (GET_WM_COMMAND_ID(wparam, lparam))
			{
				case IDOK:
					PostMessage(hdlg, WM_CLOSE, 0, 0L);
					break;

				case IDC_RUNTEST:
					// Run CPU and Display test program
					break;

				case IDC_STOP:
					// Stop CPU and Display test program
					break;

				default:
					return(TRUE);
			}
			default:
		return(FALSE);
	}
	return(FALSE);
}

//*******************************************************************
// Speed_display - handle Speed display subroutine
//
// paramaters:
//             none
//
//					resets clocks after 100 Intervalls
//*******************************************************************

void Speed_display(void)

{
	t_time++;
	if(t_time==10)					// Update display ervery 10 Intervalls
	{
		t_speed=t_check/(GetTickCount()-t_time_speed)+2;
		aw_speed=(aw_speed>>1)+(t_speed>>1);
		aw_speed=(aw_speed>>1)<<1;

		if(IsWindow(h_speed))             // display speed if window is open
		{
			wsprintf(string,TEXT("%d %%"),aw_speed);
			SetDlgItemText(h_speed,IDC_ACTUALSPEED,string);
		}
		t_time=0;
		t_time_speed=GetTickCount();
	} // end if
}


//*******************************************************************
// Detail - handle dialog messages
//
// paramaters:
//             hdlg          - The window handle for this message
//             msg	        - The message number
//             wparam        - The WPARAM parameter for this message
//             lparam        - The LPARAM parameter for this message
//
//*******************************************************************
BOOL CALLBACK  Detail(HWND hdlg, UINT msg, WPARAM wparam, LPARAM lparam)
{
	char zw[_MAX_PATH]="";
	FILE *file;
	PAINTSTRUCT	ps;	   				// used in WM_PAINT
	
	lparam;


	switch(msg)
	{
		case WM_INITDIALOG:
			// Display Help file with Detail Dialog.
			lstrcat(zw,sztFileHome);
			lstrcat(zw, "osi.txt");
			if((file=fopen(zw,"rb"))!=NULL)
			{
				fread(buffer, 1, 4096, file);
				fclose(file);
				file = NULL;
			}
			SetDlgItemText(hdlg, IDC_EDIT1, buffer);
		break;

		case WM_PAINT:
			BeginPaint(hdlg,&ps);
			EndPaint(hdlg,&ps);
			return(TRUE);

		case WM_COMMAND:
			switch (GET_WM_COMMAND_ID(wparam, lparam))
			{
				case IDOK:
					EndDialog(hdlg, TRUE);
					Clear_KeyState();
				break;

				default:
				return(TRUE);
			}
		default:
		return(FALSE);
	}
	return(FALSE);
}

//*******************************************************************
// Disassembler- handle dialog messages
//
// paramaters:
//             hdlg          - The window handle for this message
//             msg	        - The message number
//             wparam        - The WPARAM parameter for this message
//             lparam        - The LPARAM parameter for this message
//
//*******************************************************************
BOOL CALLBACK  Disasm(HWND hdlg, UINT msg, WPARAM wparam, LPARAM lparam)
{
	char ret_line[8];
	char adr[5];
	int index;
	int index1;
	PAINTSTRUCT	ps;	   				// used in WM_PAINT

	lparam;

	lstrcpy(buffer,"");
	lstrcpy(tmp,"");
	lstrcpy(ret_line,"");
	ret_line[0]=13;
	ret_line[1]=10;
	ret_line[2]=0;

	switch(msg)
	{
		case WM_INITDIALOG:

			wsprintf(adr,"%04X",0);
			SetDlgItemText(hdlg,IDC_S_ADRESSE, adr);
			Dis_adr=FALSE;
		break;

		case WM_PAINT:
			BeginPaint(hdlg,&ps);
			EndPaint(hdlg,&ps);
			return(TRUE);
		break;

		case WM_COMMAND:
			switch (GET_WM_COMMAND_ID(wparam, lparam))
			{
				case IDCANCEL:
					EndDialog(hdlg, TRUE);
					Clear_KeyState();
				break;

				case IDFILESEL1:
					get_Sadress(hdlg);						// Get current S_adress text field
					if(!Dis_adr)
					{
						MessageBox(hdlg,TEXT("Enter correct value for Start/End adress"),TEXT("Adress ERROR"), MB_ICONSTOP);
						break;
					}

					// Open selected output file.
					DiskSelect(sztFileHome,0); 					// Result in global file
					disfile=fopen(sztFileName,"wt");

					if (disfile!=NULL)                    	// Dissassemble into disfile
					{
						char buff[40];
						
						lstrcpy(buffer, ";6502 Disassembled Code by OSI Emulator\n");
						fwrite(buffer, 1, lstrlen(buffer), disfile);
						
						index=S_dis;
						
						while(index <= E_dis)
						{
							index1 = Disassemble(buff, index&0xFFFF);	//disasm

							switch (index1)
							{
								case 1:
									wsprintf(buffer,"\n%04X  %02X         %s",index&0xFFFF, Peek(index&0xFFFF), buff);
									break;
								case 2:
									wsprintf(buffer,"\n%04X  %02X %02X      %s",index&0xFFFF, 
											Peek(index&0xFFFF), Peek((index+1)&0xFFFF), buff);
									break;
								case 3:
									wsprintf(buffer,"\n%04X  %02X %02X %02X   %s",index&0xFFFF, 
											Peek(index&0xFFFF), Peek((index+1)&0xFFFF),Peek((index+2)&0xFFFF), buff);
									break;
							}
							index +=index1;

							
							
							fwrite(buffer, 1, lstrlen(buffer), disfile);
							

						}
						fclose(disfile);
					}
				break;

				case IDFILESEL2:
					get_Sadress(hdlg);						// Get current S_adress text field
					if(!Dis_adr)
					{
						MessageBox(hdlg,TEXT("Enter correct value for Start/End adress"),TEXT("Address ERROR"), MB_ICONSTOP);
						break;
					}
					// Open selected output file.
					DiskSelect(sztFileHome,0); 					// Result in global file
					disfile=fopen(sztFileName,"wb");

					if (disfile!=NULL)                    	// HEX out into disfile
						fwrite(&RAMptr[S_dis], (E_dis-S_dis+0xFF)&0xFF00, 1, disfile);

					fclose(disfile);
				break;

				case IDDIS:
					get_Sadress(hdlg);						// Get current S_adress text field

					/// Show first 200 Lines of code in scroll window
					index=S_dis;
					lstrcpy(tmp," Address Code");
					lstrcat(tmp,ret_line);
					
					for(index1=0;index1<200;index1++)
					{
						wsprintf(buffer," $%04X    ",(index)&0xFFFF);
						lstrcat(tmp,buffer);
						lstrcpy(buffer,"");
						index+=Disassemble(buffer, (index)&0xFFFF);
						lstrcat(tmp,buffer);
						lstrcat(tmp,ret_line);
					}
					SetDlgItemText(hdlg, IDC_LIST_CODE, tmp);
				break;

				default:
				return(TRUE);
			}
		default:
		return(FALSE);
	}
	return(FALSE);

}

void get_Sadress(HWND hdlg)
{
	char adr[5];

	// Get current S_adress text field
	if (GetDlgItemText(hdlg, IDC_S_ADRESSE, adr, 5)==0) 
		lstrcpy(adr,"0000");
	sscanf(adr,"%04X", &S_dis);
	wsprintf(adr,"%04X", S_dis);
	SetDlgItemText(hdlg, IDC_S_ADRESSE, adr);

	// Get current E_adress text field
	if (GetDlgItemText(hdlg, IDC_E_ADRESSE, adr, 5)==0) 
		lstrcpy(adr,"0000");
	sscanf(adr,"%04X", &E_dis);
	if (E_dis<=S_dis)
	{
		E_dis=S_dis+0x100;
		if (E_dis>0xFFFF) 
			E_dis=0xFFFF;
	}
	Dis_adr=TRUE;
	wsprintf(adr,"%04X", E_dis);
	SetDlgItemText(hdlg, IDC_E_ADRESSE, adr);

}


//*******************************************************************
// ConfigDlg - handle Dialog messages
//
// paramaters:
//             hdlg          - The window handle for this message
//             msg	        - The message number
//             wparam        - The WPARAM parameter for this message
//             lparam        - The LPARAM parameter for this message
//
//*******************************************************************
BOOL CALLBACK  ConfigDlg(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{

	int nMachine = -1;
	int nTemp = 0;
	int nCommand = GET_WM_COMMAND_ID(wParam, lParam);
	TCHAR temp[255];
	HWND hWnd;
	lParam;


	switch(msg)
	{
		case WM_INITDIALOG:
			CenterWindow( hDlg, (HWND) ghWnd_Main); 

			CheckRadioButton (hDlg, IDC_RB_C1, IDC_RB_505, IDC_RB_C1 + gMachineType);
			CheckRadioButton ( hDlg, IDC_RB_FNT1, IDC_RB_FNT3, IDC_RB_FNT1 + gCharSet);
			CheckDlgButton (hDlg, IDC_CB_ROMBASIC, gBasicEnable ? 1 : 0);
			CheckDlgButton( hDlg, IDC_CB_REVFONT, gRevFont ? 1 : 0);
			if ( gCharSet != 2)
				EnableWindow( GetDlgItem(hDlg, IDC_CB_REVFONT), 0); 
			EnableWindow( GetDlgItem(hDlg, IDC_CB_ROMBASIC),gMachineType == C4PMF ? 1 : 0);
			CheckRadioButton (hDlg, IDC_RB_5INCH, IDC_RB_8INCH, IDC_RB_5INCH + gDriveType);
			CheckDlgButton( hDlg, IDC_CB_ENABLE_DISK, gDiskEnable ? 1 : 0);
			EnableWindow( GetDlgItem(hDlg, IDC_CB_ENABLE_DISK), 
				(gMachineType == C4PMF || gMachineType == IDC_RB_C1PMF) ? 0 : 1);

			EnableWindow( GetDlgItem(hDlg, IDC_RB_5INCH), gDiskEnable);
			EnableWindow( GetDlgItem(hDlg, IDC_RB_8INCH), gDiskEnable);
			EnableWindow( GetDlgItem(hDlg, IDC_EB_NUMDRIVES), gDiskEnable);
			EnableWindow( GetDlgItem(hDlg, IDC_SPIN1), gDiskEnable);
			EnableWindow( GetDlgItem(hDlg, IDC_ST_DTEXT), gDiskEnable);
			

			hWnd = GetDlgItem(hDlg, IDC_EB_NUMDRIVES);
			if (hWnd)
			{

				*temp = (TCHAR) (_T('0') + gDriveNum);
				*(temp+1) = _T('\0');
				Edit_SetText(hWnd, temp);
				Edit_LimitText(hWnd, 1);
			}

			hWnd = GetDlgItem(hDlg, IDC_SPIN1);
			if (hWnd)
			{
				
				//set spin button range
				SendMessage(hWnd, UDM_SETRANGE, 0, (LPARAM) MAKELONG( 4, 1));

			}
				
			return FALSE;
			break;

		case WM_COMMAND:
			switch (nCommand)
			{
				case IDC_RB_FNT1:
				case IDC_RB_FNT2:
				case IDC_RB_FNT3:
					if ( HIWORD(wParam) == BN_CLICKED)
					{
						EnableWindow( GetDlgItem(hDlg, IDC_CB_REVFONT), IsDlgButtonChecked(hDlg,IDC_RB_FNT3));
					}
					break;
				case IDC_RB_C1:
				case IDC_RB_UK101:
				case IDC_RB_C1PMF:
				case IDC_RB_500:
				case IDC_RB_502:
				case IDC_RB_505:
					if ( HIWORD(wParam) == BN_CLICKED)
					{
						BOOL bSet;

						bSet = (nCommand != IDC_RB_505);
						CheckDlgButton (hDlg, IDC_CB_ROMBASIC, bSet ? 1 : 0);
						EnableWindow( GetDlgItem(hDlg, IDC_CB_ROMBASIC), bSet ? 0 : 1);
						CheckRadioButton ( hDlg, IDC_RB_FNT1, IDC_RB_FNT3, IDC_RB_FNT1 +  (nCommand == IDC_RB_UK101 ? 1 : 0 ));

						bSet = (nCommand == IDC_RB_C1PMF || nCommand == IDC_RB_505);
						CheckDlgButton(hDlg, IDC_CB_ENABLE_DISK, bSet ? 1 : 0);
						EnableWindow( GetDlgItem(hDlg, IDC_CB_ENABLE_DISK), bSet ? 0 : 1);
						if (bSet)
						{
							SetDlgItemInt(hDlg, IDC_EB_NUMDRIVES, 2, FALSE);
							CheckRadioButton (hDlg, IDC_RB_5INCH, IDC_RB_8INCH, IDC_RB_5INCH);
						}
						EnableWindow( GetDlgItem(hDlg, IDC_RB_5INCH), bSet);
						EnableWindow( GetDlgItem(hDlg, IDC_RB_8INCH), bSet);
						EnableWindow( GetDlgItem(hDlg, IDC_EB_NUMDRIVES), bSet);
						EnableWindow( GetDlgItem(hDlg, IDC_SPIN1), bSet);
						EnableWindow( GetDlgItem(hDlg, IDC_ST_DTEXT), bSet);

						

					}
					break;
 
				case IDC_CB_ENABLE_DISK:
					if (HIWORD(wParam) == BN_CLICKED)
					{
						BOOL bEnable = IsDlgButtonChecked (hDlg, IDC_CB_ENABLE_DISK);
						
						EnableWindow( GetDlgItem(hDlg, IDC_RB_5INCH), bEnable);
						EnableWindow( GetDlgItem(hDlg, IDC_RB_8INCH), bEnable);
						EnableWindow( GetDlgItem(hDlg, IDC_EB_NUMDRIVES), bEnable);
						EnableWindow( GetDlgItem(hDlg, IDC_SPIN1), bEnable);
						EnableWindow( GetDlgItem(hDlg, IDC_ST_DTEXT), bEnable);

						
					}
					break;

				case IDOK:
					{
						BOOL bDiskSet = FALSE;
						BOOL bHReset = FALSE;
						BOOL bSuccess;

						gCharSet = IsDlgButtonChecked (hDlg, IDC_RB_FNT1) ? 0 :
								   IsDlgButtonChecked (hDlg, IDC_RB_FNT2) ? 1 : 
								   IsDlgButtonChecked (hDlg, IDC_RB_FNT3) ? 2 : 0;
						
						gRevFont = IsDlgButtonChecked (hDlg, IDC_CB_REVFONT) ? 1 :	0;
						
						gBasicEnable = IsDlgButtonChecked (hDlg, IDC_CB_ROMBASIC) ? 1 :	0;

						nMachine = IsDlgButtonChecked (hDlg, IDC_RB_C1) ? C1P :
								   IsDlgButtonChecked (hDlg, IDC_RB_UK101) ? UK101 : 
								   IsDlgButtonChecked (hDlg, IDC_RB_C1PMF) ? C1PMF : 
								   IsDlgButtonChecked (hDlg, IDC_RB_500) ? C2P :
								   IsDlgButtonChecked (hDlg, IDC_RB_502) ? C4P : 
								   IsDlgButtonChecked (hDlg, IDC_RB_505) ? C4PMF : -1;

						nTemp = IsDlgButtonChecked (hDlg, IDC_CB_ENABLE_DISK) ? 1 : 0;
						if (nTemp != gDiskEnable) bHReset = TRUE;
						gDiskEnable = nTemp;

						nTemp = IsDlgButtonChecked (hDlg, IDC_RB_5INCH) ? 0 : 1;
						if (nTemp != gDriveType) bDiskSet = TRUE;
						gDriveType = nTemp;

						nTemp = GetDlgItemInt(hDlg, IDC_EB_NUMDRIVES, &bSuccess, FALSE);
						if (bSuccess)
						{
							if (nTemp != gDriveNum) bDiskSet = TRUE;
							gDriveNum = nTemp;
						}
						 
						if (bDiskSet && !bHReset)
						{
							g_DiskPort.SetDriveConfig(gDriveType, gDriveNum);
						}
						
						
						if (nMachine >= 0 && (nMachine != gMachineType) || bHReset)
						{
							if (MessageBox(hDlg, "This will hard-reset the emulator. Continue?", 
												  "Warning", MB_YESNO) == IDNO)
								return TRUE;

							gMachineType = nMachine;
							nMachine =  IDRESET;

						}
						else
						{
							nMachine =  IDOK;
						}
							
						_stprintf(temp, "%d", gCharSet);
						WritePrivateProfileString(_T("ROM"),_T("CHARSET"),temp,INIFILE);
						
						_stprintf(temp, "%d", gRevFont);
						WritePrivateProfileString(_T("ROM"),_T("FONTREV"),temp,INIFILE);

						_stprintf(temp, "%d", gBasicEnable);
						WritePrivateProfileString(_T("ROM"),_T("BASICENABLE"),temp,INIFILE);

						_stprintf(temp, "%d", gMachineType);
						WritePrivateProfileString(_T("MACHINE"),_T("TYPE"),temp,INIFILE);

						_stprintf(temp, "%d", gDiskEnable);
						WritePrivateProfileString(_T("DISK"),_T("ENABLE"),temp,INIFILE);

						_stprintf(temp, "%d", gDriveType);
						WritePrivateProfileString(_T("DISK"),_T("DRIVETYPE"),temp,INIFILE);

						_stprintf(temp, "%d", gDriveNum);
						WritePrivateProfileString(_T("DISK"),_T("NUMDRIVES"),temp,INIFILE);

						EndDialog(hDlg, nMachine);
						Clear_KeyState();
						return TRUE;	
					}
					break;
				case IDCANCEL:
					EndDialog(hDlg, IDCANCEL);
					break;
				default:
					return FALSE;
			}
		default:
			return(FALSE);
	}
	return(FALSE);
}

//*******************************************************************
// TimerProc function.
// This is the windows timer handling function.
//*******************************************************************
/*
VOID CALLBACK  TimerProc(HWND hdlg, UINT msg, UINT idevent, DWORD dwtime)
{
  if(idevent==IDT_TIMER1) timer++;
  return;
}
*/
//*******************************************************************
//
// 							WindowProc function.
//
// This is the windows message handling function.
//*******************************************************************

LRESULT CALLBACK  WindowProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam)
{
	PAINTSTRUCT	ps;	   				// used in WM_PAINT
	HMENU hMenu;
	TCHAR szBuf[255];

// message
	switch(msg)
	{
	case WM_TIMER:
		break;

	case WM_CREATE:
		return(DefWindowProc(hwnd, msg, wparam, lparam));

	case WM_ACTIVATE:
		//if (LOWORD(wparam) == WA_INACTIVE)

		//when we lose or regain focus, clear keyboard
		Clear_KeyState();
		break;
	case WM_SCREEN_UPD:
		InvalidateRect(	ghWnd_Main, NULL, FALSE);
		SetScreenCheck(gScreenMode);
		PostMessage(ghWnd_Main, WM_PAINT, 0, 0);
		break;

	case WM_COMMAND:
		switch (GET_WM_COMMAND_ID(wparam, lparam))
			{
			 case IDM_EXIT:
			  // User selected Quit on menu
				PostMessage(hwnd, WM_CLOSE, 0, 0L);
				break;

			 case IDM_ABOUT:
			 // Display about box.
				DialogBox(ghInstance,MAKEINTRESOURCE(IDD_ABOUT),hwnd,About);
				break;

			 case IDM_SYSTEMSPEED:
			 // Display modeless speed dialog box.
				if(!IsWindow(h_speed))
				{
				 // Create modeless dialog only if it's not already open
				 h_speed = CreateDialog(ghInstance,MAKEINTRESOURCE(IDD_SPEED),hwnd,(DLGPROC)S_dialog);
				 ShowWindow(h_speed,SW_SHOW);
				}
				break;
			
			case IDM_CONFIGURE:
				if (DialogBox(ghInstance, MAKEINTRESOURCE(IDD_CONFIGURE), ghWnd_Main, (DLGPROC) ConfigDlg) == IDRESET)
					PostMessage(hwnd, WM_COMMAND, IDM_HRESET, 0);
				break;
			case IDM_SERIAL:
				DialogBoxParam(ghInstance, MAKEINTRESOURCE(IDD_SERIAL), ghWnd_Main, (DLGPROC) g_SerialPort.SerialDlg, (LPARAM) &g_SerialPort );
				Clear_KeyState();
				break;

			 case IDM_DETAIL:
			 // Display Detail box.
				DialogBox(ghInstance,MAKEINTRESOURCE(IDD_DETAILS),hwnd,Detail);
				break;

			 case IDM_DISASSEMBLE:
			 // Display Disassembler box.
				DialogBox(ghInstance,MAKEINTRESOURCE(IDD_DISASM),hwnd,VideoDlg);
				break;

			 case IDM_VIDEO:
				DialogBox(ghInstance,MAKEINTRESOURCE(IDD_VIDEO),hwnd,VideoDlg);
				break;

			 case IDM_CONFIG:
			 // Display Help file with Notepad Editor.
				spawnlp(P_NOWAIT,"Notepad.exe","Notepad.exe",INIFILE , NULL);
				break;

			 case IDM_OPEN:
			 // Display OpenFile box.
					FileMenue();
				break;

			 case IDM_SAVE:
				// Display SaveFile box.
				FileSaveMenue();
				break;

			 case IDM_RESET:
			 // Soft Reset CPU
				Reset();
				break;

			 case IDM_HRESET:
			 // Reset CPU
				HReset();
				break;

			 case IDM_LARGE:
			 // Set Large resolution  
				gScreenMode=(gScreenMode & ~SCREENSIZE_MASK) | 2;
				SetScreenCheck(gScreenMode);
				break;

			 case IDM_MEDIUM:
			 // Set Medium resolution 
				gScreenMode=(gScreenMode & ~SCREENSIZE_MASK) | 1;
				SetScreenCheck(gScreenMode);
				break;

			 case IDM_SMALL:
			 // Set Small resolution      -> Bit 1=0
				gScreenMode &= ~SCREENSIZE_MASK;
				SetScreenCheck(gScreenMode);
				break;
			case IDM_OPEN_DISK1:
			case IDM_OPEN_DISK2:
			case IDM_OPEN_DISK3:
			case IDM_OPEN_DISK4:
				g_DiskPort.OpenFile( (GET_WM_COMMAND_ID(wparam, lparam) - IDM_OPEN_DISK1)+1);
				break;
			
			case IDM_CLOSE_DISK1:
			case IDM_CLOSE_DISK2:
			case IDM_CLOSE_DISK3:
			case IDM_CLOSE_DISK4:
				g_DiskPort.CloseFile( (GET_WM_COMMAND_ID(wparam, lparam) - IDM_CLOSE_DISK1)+1);
				break;

			 case IDM_MONITOR:
				if ( hWndMonitor)
				{
					Close_Monitor();
				}
				else
				{
					Open_Monitor(hwnd, "Debugger");
					// Close modeless dialog

				}
				break;

			 case IDM_GRAPHIC:
				ToggleGraphik();
				break;

			 case IDM_INT:
			 // Toggle INT CPU
				if (IEnable)
				 {
				  IEnable = FALSE;
				  CheckMenuItem( GetMenu(ghWnd_Main), IDM_INT, MF_UNCHECKED);
				 }
				else
				 {
				  IEnable = TRUE;
				  CheckMenuItem( GetMenu(ghWnd_Main), IDM_INT, MF_CHECKED);
				 }
				break;
			}

	 case WM_ERASEBKGND:
		return DefWindowProc(hwnd, msg, wparam, lparam);

	 case WM_PAINT:
		// start painting
		BeginPaint(hwnd,&ps);
		restvid();
		// end painting
		EndPaint(hwnd,&ps);
		return(TRUE);

	 case WM_CLOSE:
	  	if(IsWindow(hWndMonitor))
			Close_Monitor();
		if(IsWindow(h_speed))
			PostMessage(h_speed, WM_CLOSE, 0, 0L);
		Abort=FALSE;
		break;

	 case WM_HOTKEY:
		Clear_KeyState();
		break;
	 
	 case WM_INITMENUPOPUP:
		break;

	 case WM_INITMENU:
		{
			BOOL bEnable;
			hMenu = GetMenu (hwnd);
			CheckMenuItem(hMenu ,IDM_MONITOR, hWndMonitor ? MF_BYCOMMAND|MF_CHECKED : MF_BYCOMMAND|MF_UNCHECKED);
			EnableMenuItem(hMenu, IDM_GRAPHIC, RAMGDC ? MF_BYCOMMAND|MF_ENABLED : MF_BYCOMMAND|MF_DISABLED|MF_GRAYED);

			EnableMenuItem(hMenu, IDM_OPEN_DISK1, gDriveNum > 0 ? MF_BYCOMMAND|MF_ENABLED : MF_BYCOMMAND|MF_DISABLED|MF_GRAYED);
			EnableMenuItem(hMenu, IDM_OPEN_DISK2, gDriveNum > 1 ? MF_BYCOMMAND|MF_ENABLED : MF_BYCOMMAND|MF_DISABLED|MF_GRAYED);
			EnableMenuItem(hMenu, IDM_OPEN_DISK3, gDriveNum > 2 ? MF_BYCOMMAND|MF_ENABLED : MF_BYCOMMAND|MF_DISABLED|MF_GRAYED);
			EnableMenuItem(hMenu, IDM_OPEN_DISK4, gDriveNum > 3 ? MF_BYCOMMAND|MF_ENABLED : MF_BYCOMMAND|MF_DISABLED|MF_GRAYED);
			
			bEnable = gDriveNum > 0 && (g_DiskPort.GetSelDrives() & 1);
			EnableMenuItem(hMenu, IDM_CLOSE_DISK1, bEnable ? MF_BYCOMMAND|MF_ENABLED : MF_BYCOMMAND|MF_DISABLED|MF_GRAYED);
			bEnable = gDriveNum > 1 && (g_DiskPort.GetSelDrives() & 2);
			EnableMenuItem(hMenu, IDM_CLOSE_DISK2, bEnable ? MF_BYCOMMAND|MF_ENABLED : MF_BYCOMMAND|MF_DISABLED|MF_GRAYED);
			bEnable = gDriveNum > 2 && (g_DiskPort.GetSelDrives() & 4);
			EnableMenuItem(hMenu, IDM_CLOSE_DISK3, bEnable ? MF_BYCOMMAND|MF_ENABLED : MF_BYCOMMAND|MF_DISABLED|MF_GRAYED);
			bEnable = gDriveNum > 3 && (g_DiskPort.GetSelDrives() & 8);
			EnableMenuItem(hMenu, IDM_CLOSE_DISK4, bEnable ? MF_BYCOMMAND|MF_ENABLED : MF_BYCOMMAND|MF_DISABLED|MF_GRAYED);

			
			
			if (!g_SerialPort.IsFileOpen(TRUE))
				LoadString(ghInstance, IDS_INFILE_CLOSED, szBuf, 255);
			else
				LoadString(ghInstance, IDS_INFILE_OPEN, szBuf, 255); 
			
			ModifyMenu( hMenu, IDM_OPEN, MF_BYCOMMAND, IDM_OPEN, szBuf);
			

			if (!g_SerialPort.IsFileOpen(FALSE))
				LoadString(ghInstance, IDS_OUTFILE_CLOSED, szBuf, 255);
			else
				LoadString(ghInstance, IDS_OUTFILE_OPEN, szBuf, 255); 
			
			ModifyMenu( hMenu, IDM_SAVE, MF_BYCOMMAND, IDM_SAVE, szBuf);


			Clear_KeyState();
		}
		break;

	 case WM_KEYUP:	 //lparam bits 16-23 specify OEM scan code
		gScan = ((lparam>>16) & 0xFF) | 0x80;
		TRACE("Keyup   = 0x%X\n", gScan);
		//irqkey = gScan;
		PCtoKeystate();
		return 0;
		break;

	 case WM_SYSKEYUP:
			gScan = ((lparam>>16) & 0xFF) | 0x80;
			//irqkey = gScan;
			PCtoKeystate();
			break;

	 case WM_SYSKEYDOWN:  //F10 or ALT+Key

			gScan = (lparam>>16) & 0xFF;
			//irqkey = gScan;
			PCtoKeystate();
			if ((lparam&0x40000000)) //bit30 specifies previous keystate 1=down
			{
				//MDS why?
				//keybd_event((BYTE)wparam, (BYTE)lparam, KEYEVENTF_KEYUP, NULL);
			}
			break;

	 case WM_KEYDOWN:


		  
		  gScan = (lparam >>16) & 0xFF;
		  TRACE("KeyDown = 0x%X\n", gScan);
		  //irqkey = gScan;
		  PCtoKeystate();
		  if ( (lparam & 0x40000000) ) //bit30 specifies previous keystate 1=down
		  {
			//MDS why?
			//keybd_event((BYTE)wparam, (BYTE)lparam, KEYEVENTF_KEYUP, NULL);
		  }
		  return 0;
		  break;

	 default:
		break;

	 } // end switch

	return (DefWindowProc(hwnd, msg, wparam, lparam));

} // end WinProc


//*******************************************************************

									// SUB Open Processor Dialog //

//*******************************************************************

void Open_Processor(HWND hwnd, char *)
{
	if(!IsWindow(hWndMonitor))
	{
		// Create modeless dialog only if it's not here already
		CheckMenuItem(GetMenu(ghWnd_Main),IDM_MONITOR,MF_BYCOMMAND|MF_CHECKED);
		
		hWndMonitor=CreateDialog(ghInstance,MAKEINTRESOURCE(IDD_DEBUG),hwnd,(DLGPROC)hWndMonitor);

		ShowWindow(hWndMonitor,SW_SHOW);
		
		if(IsWindow(h_speed))
			PostMessage(h_speed, WM_CLOSE, 0, 0L);   // Removes Speed disp if present
	}
	else
	{
		// Close modeless dialog
		CheckMenuItem(GetMenu(ghWnd_Main),IDM_MONITOR,MF_BYCOMMAND|MF_UNCHECKED);
		PostMessage(hWndMonitor, WM_CLOSE, 0, 0L);
	}
}

//*******************************************************************

									// WINMAIN //

//*******************************************************************

int APIENTRY WinMain(HINSTANCE hinstance, HINSTANCE hprevinstance,
							LPSTR lpcmdline, int nCmdShow)
{

	WNDCLASS winclass;					// this will hold created class
	MSG msg;									// generic message

	TCHAR	szAppName[32];
	TCHAR   szClassName[32];
	int rcWinX, rcWinY;					// Display Zero Coordinates
	char *p;
	unsigned long int t_time_tick;
	unsigned long int clocks;

	hprevinstance;
	nCmdShow;

	// save instance in a global
	ghInstance = hinstance;

	//Load window class & app title
	LoadString(ghInstance, IDS_NAME, szAppName, 32);
	LoadString(ghInstance, IDS_CLASS, szClassName, 32);
	ghAccel = LoadAccelerators(ghInstance, MAKEINTRESOURCE(IDR_ACCELERATOR1));
			 // window class stucture
	winclass.style		  	= CS_DBLCLKS | CS_OWNDC | CS_HREDRAW | CS_VREDRAW | CS_BYTEALIGNCLIENT | CS_SAVEBITS;
	winclass.lpfnWndProc	= WindowProc;
	winclass.cbClsExtra		= 0;
	winclass.cbWndExtra		= 0;
	winclass.hInstance		= ghInstance;
	winclass.hIcon			= LoadIcon(hinstance, "IDI_CP4");
	winclass.hCursor		= LoadCursor(NULL, IDC_ARROW);
	winclass.hbrBackground	= CreateSolidBrush(WINDOW_BACK);
	winclass.lpszMenuName	= MAKEINTRESOURCE(IDM_OHIO);
	winclass.lpszClassName	= szClassName;


		// register window class
	if (!RegisterClass(&winclass)) 
		return(FALSE);

    {
		bIsNT = TRUE;

		OSVERSIONINFO osv;
		ZeroMemory(&osv, sizeof(OSVERSIONINFO));
		osv.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
		GetVersionEx(&osv);

		if (osv.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS)
			bIsNT = FALSE; //Win95+
	}
	
	
	rcWinX=0;//((GetSystemMetrics(SM_CXSCREEN)-WINDOW_WIDTH_S)>>4);
	rcWinY=0;//((GetSystemMetrics(SM_CYSCREEN)-WINDOW_HEIGHT_S)>>4);

		  // create window
	ghWnd_Main = CreateWindowEx(  WS_EX_DLGMODALFRAME,
							szClassName,
							szAppName,
							WS_SYSMENU | WS_OVERLAPPED | WS_MINIMIZEBOX | WS_VISIBLE | WS_CAPTION,
							rcWinX,rcWinY,  // x,y start position
							256,0,		  // width,height
							NULL,	     // handle to parent
							NULL,	     // handle to menu
							ghInstance,  // instance
							NULL);

	if (!ghWnd_Main) 
		return(FALSE);


	main_window = GetDC(ghWnd_Main);


	
	GetModuleFileName(hinstance, sztFileHome, MAX_PATH);           // Get Home directory
	sztFileHome[MAX_PATH-1]=0x00;
	p = strrchr(sztFileHome, '\\');
	if (p)
		*(p+1) = '\0';
	lstrcpy(sztFilePath,sztFileHome);          // Set Files start directory


	AllocMem();									// Allocate memory
	InitGlobals();

	HReset(lpcmdline);					// Load Configuration

	// perform  Osi specific initialization


	// CREATE A FONT FOR THE DEBUGGING SCREEN

	debugfont = CreateFont(-14,0,0,0,
						FW_NORMAL,0,0,0,
						ANSI_CHARSET,
						OUT_CHARACTER_PRECIS,
						CLIP_CHARACTER_PRECIS,
						DEFAULT_QUALITY,
						FIXED_PITCH,
						TEXT("Courier New"));




	///////////////////////////////// EMULATION /////////////////////////////////
	/////////////////////////////////   MAIN    /////////////////////////////////
	/////////////////////////////////  LOOPs   /////////////////////////////////


	SetScreenCheck(gScreenMode);

	if (lstrlen(ERRORTEXT)!=0) 
		Quit(ERRORTEXT);

	t_time_speed=GetTickCount();	    // Initial real Speed time measurement in ms

	// Start main emulator loop
	while(Abort)
	{
		t_time_tick=GetTickCount();     	       // Get current time in ms for Intervall control
		t_check=40000;      	 				   // Free Run Intervall to check speed
		clocks=0;                        		   // Reset clocks TO AVOID OVERFLOW !
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))  // Do Windows messaging
		{
			if (msg.message == WM_QUIT) 
				Abort=FALSE; 
			
			if (  !(ghAccel && TranslateAccelerator( ghWnd_Main, ghAccel, &msg ) ) )
		  	{
			
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}

		while(clocks<t_check)                      // Free run Intervall / Reduce Windows messaging
		{
			if (IEnable != FALSE)
			{
				if (IRQ_Interrupt > 0)
				{
					if(irq_counter++ == IRQ_Interrupt)
					{
						IRQ=1; 
						irq_counter=0;
					}
				}

				if (NMI_Interrupt > 0)
				{
					if(nmi_counter++ == NMI_Interrupt)
					{
						NMI=1; 
						nmi_counter=0;
					}
				}
			} // endif (IEnable!=FALSE)

			if (irqkey!=0)
				 PCSpecialKeystate();				// Serve PC keyboard
			
			if (SEnable) 
				clocks += _6502();					// Serve Code Instruction  if Debug Step Enable
			
			if(DEnable)								// Check for active Debug Mode
			{
				if(DebugRDY)						// Toggle Debug execution
				{
					DebugRDY=FALSE;
					if(R.PC.W==stop_loc) 
						SMode=FALSE;				// Enable Step Mode

					display_registers();

					if(PeekMessage(&msg,NULL,0,0,PM_REMOVE))
					{
						if(!IsWindow(hWndMonitor)||!IsDialogMessage(hWndMonitor,&msg))
						{
							TranslateMessage(&msg); // Update Window messages
							DispatchMessage(&msg);
						}
					}  // endif (PM_MOVE message)
				} // endif (DebugRDY)
			} // endif (DEnable)
			else
			{
				SEnable=TRUE;						// Enables Debug Step
				if(R.PC.W==stop_loc)
				{
					SMode=FALSE;					// Enable Step Mode
					PokeFlag=TRUE;

					//// handles breakpoints during debug mode ////
					if(!IsWindow(hWndMonitor)) 
						Open_Monitor(ghWnd_Main, "Debugger at STOP location");
					display_registers();
					SEnable=FALSE;
				}
			} // endelse (DEnable)    idle
		} // end While

		//// End of Free run Intervall when clocks done ////
		while((10*SpeedPos*(GetTickCount()-t_time_tick))<t_check)
		{
			SleepEx(1,TRUE);
			PCtoKeystate();		// Eliminate virtual key press error
			if (VIDCpoke) 
				restgdc(); 		// Refresh Hires graphik
		}
		/// waits for each 1 ms until real time is greater than clocks

		Speed_display();      // Calculate and update speed measurement
	} // end While Abort

	if (disfile)
	{
		fclose(disfile);
		disfile = NULL;
	}
	
	
	ReleaseDC(ghWnd_Main, main_window);
	Terminate();
	return(0);

} // end WinMain


////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
//   FUNCTION: CenterWindow (HWND, HWND)
//   PURPOSE:  Center one window over another
//   COMMENTS:
//      Dialog boxes take on the screen position that they were designed
//      at, which is not always appropriate. Centering the dialog over a
//      particular window usually results in a better position.
//
BOOL WINAPI CenterWindow (HWND hwndChild, HWND hwndParent)
{
	RECT    rChild, rParent= {0,0,0,0};
	int     wChild, hChild, wParent, hParent;
	int     wScreen, hScreen, xNew, yNew;
	HDC     hdc;
	WINDOWPLACEMENT wndpl;

	if (hwndParent == NULL)
		hwndParent = GetActiveWindow();
	if (hwndParent == NULL)
		hwndParent = GetDesktopWindow();

	wndpl.length = sizeof(WINDOWPLACEMENT);
	if (GetWindowPlacement( hwndParent, &wndpl ))
	{
		CopyRect(&rParent, &wndpl.rcNormalPosition);
	}
   
	// Get the Height and Width of the child window
	GetWindowRect (hwndChild, &rChild);
	wChild = rChild.right - rChild.left;
	hChild = rChild.bottom - rChild.top;

	// Get the Height and Width of the parent window
	//GetWindowRect (hwndParent, &rParent);
	wParent = rParent.right - rParent.left;
	hParent = rParent.bottom - rParent.top;

	// Get the display limits
	hdc = GetDC (hwndChild);
	wScreen = GetDeviceCaps (hdc, HORZRES);
	hScreen = GetDeviceCaps (hdc, VERTRES);
	ReleaseDC (hwndChild, hdc);

	// Calculate new X position, then adjust for screen
	xNew = rParent.left + ((wParent - wChild) /2);
	if (xNew < 0) 
	{
		xNew = 0;
	}
	else if ((xNew+wChild) > wScreen) 
	{
		xNew = wScreen - wChild;
	}

	// Calculate new Y position, then adjust for screen
	yNew = rParent.top  + ((hParent - hChild) /2);
	if (yNew < 0) 
	{
		yNew = 0;
	}
	else if ((yNew+hChild) > hScreen) 
	{
		yNew = hScreen - hChild;
	}

	// Set it, and return
	return SetWindowPos (hwndChild, NULL,
			xNew, yNew, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
}


////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////

int WindowResize(HWND hwnd, int HSize, int VSize)
{
	rcWinRect.left=0; rcWinRect.top=0;
	rcWinRect.right=HSize; rcWinRect.bottom=VSize;

	AdjustWindowRect(&rcWinRect,WS_OVERLAPPEDWINDOW | WS_VISIBLE,1);
	return (SetWindowPos(hwnd,HWND_TOP,0,0,rcWinRect.right-rcWinRect.left,
			  rcWinRect.bottom-rcWinRect.top,SWP_NOMOVE));
}




////////////////////////////////////////////////////////////////////////////

#define WINDOW_WIDTH_L  768          // size of window large
#define WINDOW_HEIGHT_L 768           // no full screen large
#define WINDOW_WIDTH_M  512          // size of window medium
#define WINDOW_HEIGHT_M 512           // no full screen medium
#define WINDOW_WIDTH_S  256           // size of window small
#define WINDOW_HEIGHT_S 256           // no full screen small

void SetScreenCheck(int scr)
{
	int nSet = scr & 0x03;
	BOOL bC1at64 = (scr & RESIZE_MASK) == 0 && (scr & MODE64X16 );

	if ( ((scr & RESIZE_MASK) == 0 && (scr & WIDTH_MASK)) || bC1at64 )
		nSet |= 4;

	CheckMenuItem( GetMenu(ghWnd_Main), IDM_LARGE,  (scr & SCREENSIZE_MASK) == 2 ? MF_CHECKED : MF_UNCHECKED);
	CheckMenuItem( GetMenu(ghWnd_Main), IDM_MEDIUM, (scr & SCREENSIZE_MASK) == 1 ? MF_CHECKED : MF_UNCHECKED);
	CheckMenuItem( GetMenu(ghWnd_Main), IDM_SMALL,  (scr & SCREENSIZE_MASK) == 0 ? MF_CHECKED : MF_UNCHECKED);

	//if (1)//scr != g
	const nBorderHeight = 48;
	{

		int nWidth = WINDOW_WIDTH_S;
		int nHeight = WINDOW_HEIGHT_S;
		switch (nSet)
		{
			case 0: //small screen 1:1 (32*8 x 32*8) = (256 x 256)
				nWidth  = WINDOW_WIDTH_S + HBORDER*2;
				nHeight = WINDOW_HEIGHT_S + nBorderHeight;
				break;
			case 1: //medium screen 2:1	(512 x 512)
				nWidth  = WINDOW_WIDTH_M + HBORDER*2;
				nHeight = WINDOW_HEIGHT_M + nBorderHeight;
				break;
			case 2: //large screen 3:1  (768 x 768)
				nWidth  = WINDOW_WIDTH_L + HBORDER*2;
				nHeight = WINDOW_HEIGHT_L + nBorderHeight;
				break;
			case 3:	//unused
				break;
			case 4:
				nWidth  = WINDOW_WIDTH_S*2 + HBORDER*2;
				if (bC1at64)
					nHeight = WINDOW_HEIGHT_S/2 + nBorderHeight;
				else
					nHeight = WINDOW_HEIGHT_S + nBorderHeight;

				break;
			case 5:
				nWidth  = WINDOW_WIDTH_M*2 + HBORDER*2;
				if (bC1at64)
					nHeight = WINDOW_HEIGHT_M/2 + nBorderHeight;
				else
					nHeight = WINDOW_HEIGHT_M + nBorderHeight;
				break;
			case 6:
				nWidth  = WINDOW_WIDTH_L*2 + HBORDER*2;
				if (bC1at64)
					nHeight = WINDOW_HEIGHT_L/2 + nBorderHeight;
				else	
					nHeight = WINDOW_HEIGHT_L + nBorderHeight;
			case 7:
				break;


		}
		WindowResize(ghWnd_Main, nWidth, nHeight);


		if (bC1at64)
		{
			
		}


	}
	InitVideo();

	RedrawWindow(ghWnd_Main,NULL,NULL,RDW_ERASE | RDW_INVALIDATE);
}

////////////////////////////////////////////////////////////////////////////

void Quit(char message[])
{
	
	char  text[1024];
	wsprintf(text,TEXT("%s"),message);
	MessageBox(0, text,TEXT("ERROR during System Boot"), MB_ICONSTOP);
	Abort=FALSE;
}

void ReportSystemError ( DWORD dwError)
{ 
    LPTSTR   message; 
 
    FormatMessage (FORMAT_MESSAGE_ALLOCATE_BUFFER | 
                   FORMAT_MESSAGE_FROM_SYSTEM, 
                   NULL, 
                   dwError, 
                   MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), 
                   (LPTSTR) &message, 
                   0, 
                   NULL); 
 
    MessageBox(ghWnd_Main, message, "Emulator", MB_OK); 
    LocalFree (message); 

}

void MoveControl(HWND hWnd, UINT nID, int x, int y)
{
    HWND hChild;
    RECT rect;

    if (!hWnd)
        return;
    
    hChild = GetDlgItem(hWnd, nID);
    
    if (!hChild)
        return;
    InvalidateRect(hChild, NULL, FALSE);
    GetWindowRect(hChild, &rect);
    ScreenToClient(hWnd, (LPPOINT) &rect);
    OffsetRect(&rect, x,y);

    SetWindowPos( hChild, NULL,  rect.left, rect.top, 0, 0, 
                SWP_NOZORDER|SWP_NOSIZE );

         
} // MoveControl

void GrowWindow(HWND hWnd, UINT nID, int x, int y)
{
    HWND hChild;
    RECT rect;
    
    if (!hWnd)
        return;

    hChild = GetDlgItem(hWnd, nID);  
    
    if (!hChild)
        return;

    InvalidateRect(hChild, NULL, FALSE);
    GetWindowRect(hChild, &rect);
    ScreenToClient(hWnd, (LPPOINT) &rect);

    ScreenToClient(hWnd, (LPPOINT) &rect.right);

    rect.right += x;
    rect.bottom += y;

    SetWindowPos(hChild, NULL,  0, 0, rect.right-rect.left, rect.bottom-rect.top, 
                SWP_NOZORDER|SWP_NOMOVE  );
}

void TRACE(LPCTSTR szFormat, ...)
{
	static TCHAR buf[2048];
    va_list vargs;

    if (szFormat && *szFormat) 
    {
		va_start( vargs, szFormat );
		wvsprintf( buf, szFormat, vargs );
		va_end( vargs );  

        OutputDebugString(buf);

    }

}


