// W_osi.h: interface for the Main Application
//
//////////////////////////////////////////////////////////////////////


#ifndef _W_OIS_H
#define _W_OSI_H

#include <windows.h>
#include <stdlib.h>


void SetScreenIcons(HDC hdc);
void SetScreenBotton(HDC hdc);

BOOL CALLBACK  About(HWND hdlg, UINT msg, WPARAM wparam, LPARAM lparam);
BOOL CALLBACK  ConfigDlg(HWND hdlg, UINT msg, WPARAM wparam, LPARAM lparam);
BOOL CALLBACK  S_dialog(HWND hdlg, UINT msg, WPARAM wparam, LPARAM lparam);
BOOL CALLBACK  Detail(HWND hdlg, UINT msg, WPARAM wparam, LPARAM lparam);
BOOL CALLBACK  Disasm(HWND hdlg, UINT msg, WPARAM wparam, LPARAM lparam);


void InitGlobals();
BOOL WINAPI CenterWindow (HWND hwndChild, HWND hwndParent);
int  WindowResize(HWND hwnd, int HSize, int VSize);
void SetScreenCheck(int scr);
void get_Sadress(HWND hdlg);
void Reset(void);           		// Reset CPU
void HReset(LPCSTR szINI = NULL);	// Hard Reset -restart emulation
BOOL IsNT();


extern HWND		 ghWnd_Main; 	// global main window handle
extern HINSTANCE ghInstance; 	// global instance
extern int		 gMachineClass; // C1 or C2 style? emulation mode

// 0=OSI C1P     4= OSI 502
// 1=UK101		 5= OSI 505
// 2=OSIC1PMF
// 3=OSI 500
extern int      gMachineType;  // CPU & I/O

extern int      gCharSet;		// character generator type
extern int		gRevFont;		// char gen stored right to left
extern int      gBasicEnable;	// Enable Basic at $A000
extern int      gKernelType;	// 0 = SYN600, 1=CEGMON
extern int		gDiskEnable;	// Is disk controller enabled
extern int		gDriveType;		// 0=5.25, 1=8
extern int		gDriveNum;		// 1-4

extern HDC		 main_window;   // main window hdc

extern DWORD	 gClocks;		// number of CPU ticks
extern BOOL		 IEnable;       // Enables Interrupt function (MMI + IRQ)
extern unsigned long int IRQ_Interrupt; //#clocks to pass before serving IRQ (?)
extern unsigned long int NMI_Interrupt;	//#clocks to pass before serving NMI (?)

extern BOOL VIDCpoke;			// Text write Flag for Hires
extern RECT	rcWinRect;


extern int tape_1s;		  // Select indicators

extern unsigned int RAMTOPadr;	// default 03FF Ramtop 1kb
extern unsigned int KERNALadr;	// default D000 VIDC Startadress l=0800
extern unsigned int BASICadr;		// default A000 BASIC ROM Startadresse l=2000
extern unsigned int RAMEX1,RAMEX2,ROMEX1,ROMEX2,ROMEX3; // Extension RAM,ROM
extern unsigned int RAMEX1size,RAMEX2size,ROMEX1size,ROMEX2size,ROMEX3size;



extern unsigned char far *RAMptr;   // Universal 64k memry area
extern unsigned int RAMTOP, stop_loc;
extern HWND	h_speed ;				// Handle of Speed dialog
extern HFONT debugfont;				// Debug Font

extern char BAS[_MAX_PATH];
extern char MON[_MAX_PATH];
extern char CHARGEN[_MAX_PATH];
extern char KEYTABLE[_MAX_PATH];
extern char INIFILE[_MAX_PATH];
extern char ERRORTEXT[1024];
extern char ROMEX1file[_MAX_PATH];			// Extension ROM file names
extern char ROMEX2file[_MAX_PATH];			// Extension ROM file names
extern char ROMEX3file[_MAX_PATH];			// Extension ROM file names


enum eMachineClass 
{
	 NoMachine = 0,
	 C1Machine = 1,
	 C2Machine = 2
};

enum eMachineType
{
	C1P = 0,	//C1P, Supoerboard, OSI charset
	UK101,		//UK101, Supoerboard, UK101 charset
	C1PMF,		//C1P with floppies?
	C2P,		//OSI 500 CPU & Basic in ROM
	C4P,		//OSI 502 CPU & Basic in ROM
	C4PMF,		//OSI 505 CPU & dual floppies 48K ram
	CUSTOM		// User defined
};

enum eKernelType
{
	SYN600 = 0,
	CEGMON = 1
};

#define WINDOW_BACK 0x600000			// Background Color
#define C_WHITE (RGB(255,255,255))
#define C_BLACK (RGB(0,0,0))
#define WM_SCREEN_UPD	WM_USER+300

//helpers
void MoveControl(HWND hWnd, UINT nID, int x, int y);
void GrowWindow(HWND hWnd, UINT nID, int x, int y);


//Debugging  Print debug message
void	TRACE(LPCSTR szFormat, ...);
void	ReportSystemError ( DWORD dwError);



#endif //_W_OSI_H



